<template>
    <div  id="app">
        <Header
            v-on:clear-all="clearAll"
            v-on:searchText="searchText"
        />
        <Sidebar
            v-bind:usersData="usersData"
            v-bind:filter-key="filterKey"
            v-bind:open-user-data="openUserData"
            v-on:unselect-user="unselectUser"
            v-on:select-user="selectUser"
            v-on:open-user="openUser"

        />
        <Footer />
    </div>
</template>

<script>

    import Header from './components/Header';
    import Footer from './components/Footer';
    import Sidebar from './components/Sidebar';
    import axios from 'axios';


    export default {
    name: 'App',
    components: {
        Sidebar,
        Footer,
        Header,
    },
    mounted() {
        const selectedUserList = JSON.parse(sessionStorage.getItem('selected')) || [];

        axios.get(this.url).then((response) => {
            let users = response.data;

            this.usersData = users.map((user) => {
                user.selected = selectedUserList.includes(user.id);
                return user
            });
        });
    },
    data() {
        return {
            url: 'https://api.github.com/users',
            usersData: [],
            filterKey: '',
            openUserData: null,
        }
    },
        methods: {
            searchText(key) {
                this.filterKey = key;
            },
            clearAll() {
                const selectedUserList = JSON.parse(sessionStorage.getItem('selected')) || [];
                selectedUserList.forEach((id) => this.unselectUser(id))
            },
            unselectUser(id) {
                this.add_removeUser(id, false);
                this.add_removeToStorage(id, false);

            },
            selectUser(id) {
                this.add_removeUser(id, true);
                this.add_removeToStorage(id, true);

            },
            openUser(login){
                let user = null;
                axios.get(`${this.url}/${login}`).then((response) => {
                    user= response.data;
                    if (!this.openUserData) {
                        this.openUserData= user
                    } else {
                        this.openUserData = null
                    }
                });
             },
            add_removeUser(id, status) {
                for (let index = 0; index < this.usersData.length; index++) {
                    if (this.usersData[index].id === id) {
                        this.usersData[index].selected = status
                    }
                }
            },

            add_removeToStorage(id, status) {
                const selectedUserList = JSON.parse(sessionStorage.getItem('selected')) || [];
                const index = selectedUserList.indexOf(id);

                if (status && index === -1){
                    selectedUserList.push(id)
                }
                if (!status && index + 1) {
                    selectedUserList.splice(index,1);
                }
                sessionStorage.setItem('selected', JSON.stringify(selectedUserList))
            }
        },
}

</script>

<style>
#app {
    width: 100%;
    min-width: 1040px;
    font-family: Avenir, Helvetica, Arial, sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    text-align: center;
    color: #2c3e50;
    margin-top: 0;
}
</style>
